Status: Resolved % Done: 0%

Priority: High Spent time: 0.00 hour

Assignee:    

Category: OSD   

Target version: v0.52a   

Source: Development Affected Versions:  

Tags:  ceph-qa-suite:  

Backport:  Pull request ID:  

Regression: No Crash signature (v1):  

Severity: 3 - minor Crash signature (v2):  

Reviewed:    

Description

node02:/data/ceph_backend# ceph-osd -c /etc/ceph/ceph.conf -i 1 --mkfs --monmap

/tmp/monmap  --mkkey

2012-08-26 23:43:24.572064 f733e710 -1 filestore(/data/ceph_backend/osd) mkfs:

BTRFS_IOC_SUBVOL_CREATE failed with error (22) Invalid argument

2012-08-26 23:43:24.572088 f733e710 -1 OSD::mkfs: FileStore::mkfs failed with

error -22

2012-08-26 23:43:24.572104 f733e710 -1  ** ERROR: error creating empty object

store in /data/ceph_backend/osd: (22) Invalid argument

 

It looks as if ext3 is returning EINVAL instead of the expected EOPNOTSUPP.

Associated revisions

Revision 71cfaf1c - 11/16/2012 12:50 AM - Sage Weil 

os/FileStore: only try BTRFS_IOC_SUBVOL_CREATE on btrfs

Only try to create a btrfs subvolume if the fs is btrfs.  Otherwise, just

create a directory.  Then we can error out on any ioctl error, and not

rely on the ioctl error code to determine if we failed because we are on

a non-btrfs or a real error.

Fixes: #3052

Signed-off-by: Sage Weil <sage@inktank.com>

Reviewed-by: Dan Mick <dan.mick@inktank.com>

History

#1 - 09/11/2012 04:12 PM - Dan Mick

IRC user mrjack_ confirms that this (from Greg) fixes the problem:

diff --git a/src/os/FileStore.cc b/src/os/FileStore.cc

    index 42f4705..d947237 100644

    --- a/src/os/FileStore.cc

    +++ b/src/os/FileStore.cc
    @ -1030,7 +1030,7 @ int FileStore::mkfs()

         strcpy(volargs.name, "current");

         if (::ioctl(basedir_fd, BTRFS_IOC_SUBVOL_CREATE, (unsigned long int)&volargs)) {

           ret = -errno;

    -      if (ret  -EOPNOTSUPP || ret  -ENOTTY) {

    +      if (ret < 0) {

            dout(2) << " BTRFS_IOC_SUBVOL_CREATE ioctl failed, trying mkdir " 

                    << current_fn << dendl;

     #endif

#2 - 11/15/2012 04:40 PM - Sage Weil

- Status changed from New to Fix Under Review

#3 - 11/15/2012 04:47 PM - Sage Weil

- Status changed from Fix Under Review to Resolved

71cfaf1cc5b1d77676aaf0be6daa15d4ab303386
